# Coding Interview University

> Първоначално създадох това като кратък списък с теми за учене, за ставане на софтуерен инженер, но то се разрасна до този огромен списък, който виждате в момента. След като преминах през този учебен план, [бях нает като софтуерен инженер в Amazon](https://startupnextdoor.com/ive-been-acquired-by-amazon/?src=ciu)! Най-вероятно няма да Ви се налага да учите колкото мен, но все пак всичко, от което се нуждаете е тук.
>
> Учих по около 8-12 часа на ден за няколко месеца. Това е историята ми: [Why I studies full-time for 8 months for a Google interview](https://medium.freecodecamp.org/why-i-studied-full-time-for-8-months-for-a-google-interview-cc662ce9bb13)
>
> **Моля обърнете внимание:** Няма да Ви се налага да учите колкото мен. Загубих много време, учейки неща, които нямах нужда да знам. Може да прочетете повече за това надолу. Ще Ви помогна да достигнете до крайната цел без да прахосвате скъпото си време.
>
> Темите, изредени тук, ще Ви подготвят добре за техническо интервю за почти всяка една компания, включително гигантите Amazon, Facebook, Google и Microsoft
>
> _Пожелавам Ви успех!_

<details>
<summary>Преводи:</summary>

-   [中文版本](translations/README-cn.md)
-   [Tiếng Việt - Vietnamese](translations/README-vi.md)
-   [Español](translations/README-es.md)
-   [Português Brasileiro](translations/README-ptbr.md)
-   [Polish](translations/README-pl.md)
-   [繁體中文](translations/README-tw.md)
-   [Japanese (日本語)](translations/README-ja.md)
-   [Russian](translations/README-ru.md)
-   [German](translations/README-de.md)
-   [Bahasa Indonesia](translations/README-id.md)
-   [ខ្មែរ - Khmer](translations/README-kh.md)
-   [Uzbek](translations/README-uz.md)

</details>

<details>
<summary>Текущи преводи:</summary>

-   [हिन्दी](https://github.com/jwasham/coding-interview-university/issues/81)
-   [עברית](https://github.com/jwasham/coding-interview-university/issues/82)
-   [Arabic](https://github.com/jwasham/coding-interview-university/issues/98)
-   [Turkish](https://github.com/jwasham/coding-interview-university/issues/90)
-   [French](https://github.com/jwasham/coding-interview-university/issues/89)
-   [Українська](https://github.com/jwasham/coding-interview-university/issues/106)
-   [Korean(한국어)](https://github.com/jwasham/coding-interview-university/issues/118)
-   [Telugu](https://github.com/jwasham/coding-interview-university/issues/117)
-   [Urdu](https://github.com/jwasham/coding-interview-university/issues/519)
-   [Thai](https://github.com/jwasham/coding-interview-university/issues/156)
-   [Greek](https://github.com/jwasham/coding-interview-university/issues/166)
-   [Malayalam](https://github.com/jwasham/coding-interview-university/issues/239)
-   [Bulgarian](https://github.com/jwasham/coding-interview-university/issues/1032)

</details>

<div align="center">
	<hr />
    <p>
        <a href="https://github.com/sponsors/jwasham"><strong>Become a sponsor</strong> and support Coding Interview University!</a>
    </p>
    <p>
        <strong>Special thanks to:</strong>
    </p>
    <p>
        <a href="https://oss.capital/">
            <div>
                <img src="https://d3j2pkmjtin6ou.cloudfront.net/sponsors/oss-capital.svg" width="350" alt="OSS Capital">
            </div>
            <div>
                <sup><strong>Founded in 2018, OSS Capital is the first and only venture capital platform focused<br>exclusively on supporting early-stage COSS (commercial open source) startup founders.</strong></sup>
            </div>
        </a>
    </p>
    <br />
    <p>
        <a href="https://www.gitpod.io/?utm_campaign=jwasham&utm_medium=referral&utm_content=coding-interview-university&utm_source=github">
            <div>
                <img src="https://d3j2pkmjtin6ou.cloudfront.net/sponsors/gitpod-logo-light-theme.svg" width="300" alt="Gitpod">
            </div>
            <div>
                <p>
                    <strong>Dev environments built for the cloud</strong>
                </p>
            </div>
            <div>
                <sup>Natively integrated with GitLab, GitHub, and Bitbucket, Gitpod automatically and continuously prebuilds dev environments for all your branches. As a result team members can instantly start coding with fresh dev environments for each new task - no matter if you are building a new feature, want to fix a bug, or work on a code review.</sup>
            </div>
        </a>
    </p>
    <hr />
</div>

## Какво е това?

![Coding at the whiteboard - from HBO's Silicon Valley](https://d3j2pkmjtin6ou.cloudfront.net/coding-at-the-whiteboard-silicon-valley.png)

Това е моят многомесечен план за ставане на софтуерен инженер към голяма компания.

**Изисквания:**

-   Малко опит с програмиране (променливи, цикли, методи/функции и т.н)
-   Търпение
-   Време

Забележете, че това е учебен план за **софтуерно инженерство**, а не уеб разработка. Големите компании като Google, Amazon, Facebook и Microsoft различават софтуерното инженерство и уеб разработката. Amazon, например, имат Frontend инженери (FEE) и Software Development инженери (SDE). Това са 2 отделни позиции и интервютата за тях няма да са еднакви, тъй като всяка една от тях има своите специфики. Тези компании изискват знания по компютърни науки за позиции свързани с софтуерно инженерство/разработка

---

## Съдържание

### Учебният план

-   [Какво е това?](#какво-е-това)
-   [Защо да го ползвате?](#защо-да-го-ползвате)
-   [Как да го ползвате?](#как-да-го-ползвате)
-   [Не мислете, че не сте достатъчно умни](#не-мислете-че-не-сте-достатъчно-умни)
-   [Бележка за видео ресурсите](#бележка-за-видео-ресурсите)
-   [Изберете език за програмиране](#изберете-език-за-програмиране)
-   [Книги за структури от данни и алгоритми](#книги-за-структури-от-данни-и-алгоритми)
-   [Книги за подготовка за интервю](#книги-за-подготовка-за-интервю)
-   [Не повтаряйте грешките ми](#не-повтаряйте-грешките-ми)
-   [Какво няма да намерите тук](#какво-няма-да-намерите-тук)
-   [Дневния план](#дневния-план)
-   [Подготовка за въпроси за програмиране](#подготовка-за-въпроси-за-програмиране)
-   [Задачи по програмиране](#задачи-по-програмиране)

### Теми за учене

-   [Алгоритмична сложност / Big-O / Асимптотичен анализ](#алгоритмична-сложност--big-o--асимптотичен-анализ)
-   [Структури от данни](#структури-от-данни)
    -   [Масиви (Arrays)](#масиви)
    -   [Свързани списъци(Linked Lists)](#свързани-списъци)
    -   [Стек (Stack)](#стек)
    -   [Опашка (Queue)](#опашка)
    -   [Хеш таблици (Hash table)](#хеш-таблици)
-   [Повече знания](#повече-знания)
    -   [Двоично търсене (Binary search)](#двоично-търсене)
    -   [Побитови операции (Bitwise operations)](#побитови-операции)
-   [Дървета](#дървета)
    -   [Дървета - бележки & основи](#дървета---бележки--основи)
    -   [Дървета за двоично търсене: BSTs (Binary search trees)](#дървета-за-двоично-търсене-bsts)
    -   [Heap / Priority Queue / Binary Heap](#heap--priority-queue--binary-heap)
    -   балансирани дървета за търсене (основна концепция, без детайли)
    -   обхождане: preorder, inorder, postorder, BFS, DFS
-   [Сортиране (Sorting)](#сортиране)
    -   selection
    -   insertion
    -   heapsort
    -   quicksort
    -   merge sort
-   [Графи (Graphs)](#графи)
    -   directed
    -   undirected
    -   adjacency matrix
    -   adjacency list
    -   traversals: BFS, DFS
-   [Още повече знания](#още-повече-знания)
    -   [Рекурсия (Recursion)](#рекурсия)
    -   [Динамично програмиране (Dynamic programming)](#динамично-програмиране)
    -   [Design Patterns](#design-patterns)
    -   [Комбинаторика & вероятности](#комбинаторика--вероятности)
    -   [NP, NP-Complete and Approximation Algorithms](#np-np-complete-and-approximation-algorithms)
    -   [Как компютрите обработват една програма](#как-компютрите-обработват-една-програма)
    -   [Кеширане (Caches)](#кеширане)
    -   [Процеси и нишки](#процеси-и-нишки)
    -   [Тестване (Testing)](#тестване)
    -   [String searching & manipulations](#string-searching--manipulations)
    -   [Tries](#tries)
    -   [Floating Point Numbers](#floating-point-numbers)
    -   [Уникод (Unicode)](#уникод)
    -   [Endianness](#endianness)
    -   [Мрежи (Networking)](#мрежи)
-   [Последен преглед](#последен-преглед)

### Как да спечелите позицията

-   [Актуализирайте резюмето си](#актуализирайте-резюмето-си)
-   [Намерете позиция](#намерете-позиция)
-   [Процесът на интервюто & обща подготовка](#процесът-на-интервюто--обща-подготовка)
-   [Мислете за това, когато дойде интервюто](#мислете-за-това-когато-дойде-интервюто)
-   [Подгответе въпроси за интервюиращия](#подгответе-въпроси-за-интервюиращия)
-   [След като са Ви наели](#след-като-са-ви-наели)

**---------------- Всичко оттук надолу е по желание ----------------**

### Допълнителни теми и ресурси

-   [Допълнителни книги](#допълнителни-книги)
-   [Системен дизайн, мащабируемост, обработка на данни](#системен-дизайн-мащабируемост-обработка-на-данни) (ако имате над 4 години опит)
-   [Additional Learning](#additional-learning)
    -   [Компилатори](#компилатори)
    -   [Emacs and vi(m)](#emacs-and-vim)
    -   [Unix command line tools](#unix-command-line-tools)
    -   [Information theory](#information-theory-videos)
    -   [Паритет & код на Хаминг](#паритет--код-на-хаминг)
    -   [Ентропия](#ентропия)
    -   [Криптография](#криптография)
    -   [Компресия](#компресия)
    -   [Компютърна сигурност](#компютърна-сигурност)
    -   [Garbage collection](#garbage-collection)
    -   [Паралелно програмиране](#паралелно-програмиране)
    -   [Системи за съобщения, сериализация и queueing](#системи-за-съобщения-сериализация-и-queueing)
    -   [A\*](#a)
    -   [Fast Fourier Transform](#fast-fourier-transform)
    -   [Bloom Filter](#bloom-filter)
    -   [HyperLogLog](#hyperloglog)
    -   [Locality-Sensitive Hashing](#locality-sensitive-hashing)
    -   [van Emde Boas Trees](#van-emde-boas-trees)
    -   [Разширени структури от данни](#разширени-структури-от-данни)
    -   [Балансирани дървета за търсене](#балансирани-дървета-за-търсене)
        -   AVL trees
        -   Splay trees
        -   Red/black trees
        -   2-3 search trees
        -   2-3-4 Trees (aka 2-4 trees)
        -   N-ary (K-ary, M-ary) trees
        -   B-Trees
    -   [k-D Trees](#k-d-trees)
    -   [Skip lists](#skip-lists)
    -   [Мрежови потоци](#мрежови-потоци)
    -   [Disjoint Sets & Union Find](#disjoint-sets--union-find)
    -   [Математика за бърза обработка](#математика-за-бърза-обработка)
    -   [Treap](#treap)
    -   [Линейно програмиране](#линейно-програмиране)
    -   [Geometry, Convex hull](#geometry-convex-hull-videos)
    -   [Дискретна математика](#дискретна-математика)
    -   [Machine Learning](#machine-learning)
-   [Допълнителни детайли по някои теми](#допълнителни-детайли-по-някои-теми)
-   [Видео серии](#видео-серии)
-   [Курсове по компютърни науки](#курсове-по-компютърни-науки)
-   [Papers](#papers)

---

## Защо да го ползвате?

Ако искате да работите като софтуерен инженер в голяма компания, това са нещата, които трябва да знаете.

Ако също като мен не сте учили компютърни науки в университет това ще Ви помогне да наваксате и ще Ви спести години.

Когато започнах този проект не знаех какво е стек или опашка, нямах представа какво е Big-O, не знаех нищо за дървета или как да обхождам графи. Ако трябваше да напиша сортиращ алгоритъм мога да Ви кажа, че бих се справил ужасно. Всяка от структурите от данни, които бях използвал досега бяха имплементирани в езика, който ползвах и нямах представа как работят реално. Никога не ми се беше налагало да управлявам памет освен ако някой от процесите, които бях пуснал не връщаха грешка "out of memory"- тогава се налагаше да търся заобиколен път. Бях ползвал хиляди асоциативни масиви и многоизмерни масиви няколко пъти, но никога преди не бях имплементирал структури от данни от нулата.

Планът е дълъг. Може да Ви отнеме месеци. Ако вече сте запознати с повечето от темите ще Ви отнеме многи по-малко

## Как да го ползвате

Всичко надолу е само схематично изложение и трябва да преминете през темите от горе до долу.

## Не мислете, че не сте достатъчно умни

-   Успешните софтуерни инженери са умни, но много имат чувството, че не са достатъчно умни
-   [Митът за гениалния програмист](https://www.youtube.com/watch?v=0SARbwvhupQ)
-   [Опасно е да сте сами: битката с невидимите чудовища в IT](https://www.youtube.com/watch?v=1i8ylq4j_EY)

## Бележка за видео ресурсите

Някои видеа са достъпни само след записване в курс на Coursera или EdX- т.нар. MOOCs. Понякога се налага да изчакате няколко месеца, за да стартира ново издание на курса, така че няма да имате достъп до тях.

Би било чудесно такива ресурси да бъдат заменену с безплатни и винаги-достъпни публични източници като YouTube видеота (по възможност университетски лекции), за да могат всички да учат навсякъде и по всяко време, а не само когато даден курс върви в момента.

## Изберете език за програмиране
